### Eclipse Workspace Patch 1.0
#P xwiki-core-rendering-macro-rss
Index: src/main/java/org/xwiki/rendering/internal/macro/rss/RssMacro.java
===================================================================
--- src/main/java/org/xwiki/rendering/internal/macro/rss/RssMacro.java	(revision 17791)
+++ src/main/java/org/xwiki/rendering/internal/macro/rss/RssMacro.java	(working copy)
@@ -122,9 +122,7 @@
             Block titleBlock = new LinkBlock(
                 getParserUtils().parseInlineNonWiki(entry.getTitle()), titleLink, true);
             ParagraphBlock paragraphTitleBlock = new ParagraphBlock(Collections.singletonList(titleBlock));
-            if (parameters.isCss()) {
-                paragraphTitleBlock.setParameter(CLASS_ATTRIBUTE, "rssitemtitle");
-            }
+            paragraphTitleBlock.setParameter(CLASS_ATTRIBUTE, "rssitemtitle");
             parentBlock.addChild(paragraphTitleBlock);
             
             if (parameters.isContent() && entry.getDescription() != null) {
@@ -138,9 +136,7 @@
                     entry.getDescription().getValue(), context.isInline());
 
                 XMLElement xmlElement = new XMLElement("div");
-                if (parameters.isCss()) {
-                    xmlElement.setAttribute(CLASS_ATTRIBUTE, "rssitemdescription");
-                }
+                xmlElement.setAttribute(CLASS_ATTRIBUTE, "rssitemdescription");
                 parentBlock.addChild(new XMLBlock(Arrays.asList(html), xmlElement));
             }
         }
@@ -177,15 +173,13 @@
         BoxMacroParameters boxParameters = new BoxMacroParameters();
         boolean hasImage = parameters.isImage() && feed.getImage() != null;
 
-        if (parameters.isCss()) {
-            boxParameters.setCssClass("rssfeed");
-        }
+        boxParameters.setCssClass("rssfeed");
         
         if (!StringUtils.isEmpty(parameters.getWidth())) {
             boxParameters.setWidth(parameters.getWidth());
         }
         
-        renderFeedOrEntryTitle(boxParameters, parameters.isCss(), "rsschanneltitle", feed.getTitle(), feed.getLink());
+        renderFeedOrEntryTitle(boxParameters, "rsschanneltitle", feed.getTitle(), feed.getLink());
 
         List<Block> result = null;
         if (hasImage) {
@@ -203,12 +197,11 @@
     /**
      * Renders the RSS's title.
      * @param boxParameters the BoxParameters where the title will be fitted
-     * @param isCss whether CSS formatting should be applied
      * @param cssClass the CSS sheet
      * @param title the title's text
      * @param link the title's link (if there is one)
      */
-    private void renderFeedOrEntryTitle(BoxMacroParameters boxParameters, boolean isCss, 
+    private void renderFeedOrEntryTitle(BoxMacroParameters boxParameters, 
         String cssClass, String title, String link) {
         List<Block> titleBlocks = null;
         
@@ -222,9 +215,7 @@
             titleBlocks = Collections.singletonList(linkBlock);
         }
         ParagraphBlock titleBlock = new ParagraphBlock(titleBlocks);
-        if (isCss) {
-            titleBlock.setParameter(CLASS_ATTRIBUTE, cssClass);
-        }
+        titleBlock.setParameter(CLASS_ATTRIBUTE, cssClass);
         
         boxParameters.setBlockTitle(Collections.singletonList(titleBlock));
     }
Index: src/test/java/org/xwiki/rendering/macro/rss/TestRssMacro2.java
===================================================================
--- src/test/java/org/xwiki/rendering/macro/rss/TestRssMacro2.java	(revision 17791)
+++ src/test/java/org/xwiki/rendering/macro/rss/TestRssMacro2.java	(working copy)
@@ -22,7 +22,6 @@
     {
         RssMacroParameters rssParameters = new RssMacroParameters();
         rssParameters.setContent(true);
-        rssParameters.setCss(true);
         rssParameters.setCount(1);
         rssParameters.setImage(false);
         
Index: src/main/java/org/xwiki/rendering/macro/rss/RssMacroParameters.java
===================================================================
--- src/main/java/org/xwiki/rendering/macro/rss/RssMacroParameters.java	(revision 17791)
+++ src/main/java/org/xwiki/rendering/macro/rss/RssMacroParameters.java	(working copy)
@@ -60,12 +60,6 @@
     private String width = StringUtils.EMPTY;
 
     /**
-     * If "true" then adds class id elements (rssitem, rssitemtitle, rssitemdescription, rsschanneltitle, etc) which you
-     * can style by modifying your skin's CSS file.
-     */
-    private boolean css = true;
-
-    /**
      * The RSS feed URL.
      */
     private URL feedURL;
@@ -125,23 +119,6 @@
     }
 
     /**
-     * @param css whether to add class id elements (rssitem, rssitemtitle, rssitemdescription, rsschanneltitle, etc).
-     */
-    @ParameterDescription("Specifies whether to add class id elements (rssitem, rssitemtitle, rssitemdescription etc).")
-    public void setCss(boolean css)
-    {
-        this.css = css;
-    }
-
-    /**
-     * @return whether to add class id elements (rssitem, rssitemtitle, rssitemdescription, rsschanneltitle, etc).
-     */
-    public boolean isCss()
-    {
-        return this.css;
-    }
-
-    /**
      * @param count the number of feed items to display.
      */
     @ParameterDescription("The maximum number of feed items to display on the page.")
Index: src/test/java/org/xwiki/rendering/macro/rss/TestRssMacro.java
===================================================================
--- src/test/java/org/xwiki/rendering/macro/rss/TestRssMacro.java	(revision 17791)
+++ src/test/java/org/xwiki/rendering/macro/rss/TestRssMacro.java	(working copy)
@@ -48,7 +48,6 @@
     {
         RssMacroParameters rssParameters = new RssMacroParameters();
         rssParameters.setContent(true);
-        rssParameters.setCss(true);
         rssParameters.setCount(2);
         rssParameters.setImage(true);
         