Index: xhtml2fo.xsl
===================================================================
--- xhtml2fo.xsl	(revision 18112)
+++ xhtml2fo.xsl	(working copy)
@@ -70,7 +70,7 @@
         <xsl:attribute name="writing-mode"><xsl:value-of select="$writing-mode"/></xsl:attribute>
         <xsl:attribute name="hyphenate"><xsl:value-of select="$hyphenate"/></xsl:attribute>
         <xsl:attribute name="text-align"><xsl:value-of select="$text-align"/></xsl:attribute>
-        <xsl:attribute name="font-family">FreeSans,sans-serif</xsl:attribute>
+        <xsl:attribute name="font-family">Times,sans-serif</xsl:attribute>
         <!-- specified on fo:root to change the properties' initial values -->
     </xsl:attribute-set>
 
@@ -104,72 +104,72 @@
     <xsl:attribute-set name="h1">
         <xsl:attribute name="font-size">2em</xsl:attribute>
         <xsl:attribute name="font-weight">bold</xsl:attribute>
-        <xsl:attribute name="font-style">italic</xsl:attribute>
-        <xsl:attribute name="space-before">0.67em</xsl:attribute>
-        <xsl:attribute name="space-after">0.07em</xsl:attribute>
+        <xsl:attribute name="font-style">normal</xsl:attribute>
+        <xsl:attribute name="space-before">0.8em</xsl:attribute>
+        <xsl:attribute name="space-after">0.2em</xsl:attribute>
         <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
         <xsl:attribute name="keep-together.within-column">always</xsl:attribute>
-        <xsl:attribute name="start-indent">1mm</xsl:attribute>
+        <xsl:attribute name="start-indent">0mm</xsl:attribute>
     </xsl:attribute-set>
 
     <xsl:attribute-set name="h2">
         <xsl:attribute name="font-size">1.5em</xsl:attribute>
         <xsl:attribute name="font-weight">bold</xsl:attribute>
-        <xsl:attribute name="font-style">italic</xsl:attribute>
-        <xsl:attribute name="space-before">0.83em</xsl:attribute>
-        <xsl:attribute name="space-after">0.13em</xsl:attribute>
+        <xsl:attribute name="font-style">normal</xsl:attribute>
+        <xsl:attribute name="space-before">0.8em</xsl:attribute>
+        <xsl:attribute name="space-after">0.2em</xsl:attribute>
         <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
         <xsl:attribute name="keep-together.within-column">always</xsl:attribute>
-        <xsl:attribute name="start-indent">2mm</xsl:attribute>
+        <xsl:attribute name="start-indent">0mm</xsl:attribute>
     </xsl:attribute-set>
 
     <xsl:attribute-set name="h3">
         <xsl:attribute name="font-size">1.17em</xsl:attribute>
         <xsl:attribute name="font-weight">bold</xsl:attribute>
-        <xsl:attribute name="font-style">italic</xsl:attribute>
-        <xsl:attribute name="space-before">1.0em</xsl:attribute>
-        <xsl:attribute name="space-after">0.3em</xsl:attribute>
+        <xsl:attribute name="font-style">normal</xsl:attribute>
+        <xsl:attribute name="space-before">0.8em</xsl:attribute>
+        <xsl:attribute name="space-after">0.2em</xsl:attribute>
         <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
         <xsl:attribute name="keep-together.within-column">always</xsl:attribute>
-        <xsl:attribute name="start-indent">3mm</xsl:attribute>
+        <xsl:attribute name="start-indent">0mm</xsl:attribute>
     </xsl:attribute-set>
 
     <xsl:attribute-set name="h4">
         <xsl:attribute name="font-size">1em</xsl:attribute>
         <xsl:attribute name="font-weight">bold</xsl:attribute>
-        <xsl:attribute name="font-style">italic</xsl:attribute>
-        <xsl:attribute name="space-before">1.17em</xsl:attribute>
-        <xsl:attribute name="space-after">0.47em</xsl:attribute>
+        <xsl:attribute name="font-style">normal</xsl:attribute>
+        <xsl:attribute name="space-before">0.8em</xsl:attribute>
+        <xsl:attribute name="space-after">0.2em</xsl:attribute>
         <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
         <xsl:attribute name="keep-together.within-column">always</xsl:attribute>
-        <xsl:attribute name="start-indent">4mm</xsl:attribute>
+        <xsl:attribute name="start-indent">0mm</xsl:attribute>
     </xsl:attribute-set>
 
     <xsl:attribute-set name="h5">
         <xsl:attribute name="font-size">0.85em</xsl:attribute>
         <xsl:attribute name="font-weight">bold</xsl:attribute>
-        <xsl:attribute name="font-style">italic</xsl:attribute>
-        <xsl:attribute name="space-before">1.33em</xsl:attribute>
-        <xsl:attribute name="space-after">0.63em</xsl:attribute>
+        <xsl:attribute name="font-style">normal</xsl:attribute>
+        <xsl:attribute name="space-before">0.8em</xsl:attribute>
+        <xsl:attribute name="space-after">0.2em</xsl:attribute>
         <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
         <xsl:attribute name="keep-together.within-column">always</xsl:attribute>
-        <xsl:attribute name="start-indent">5mm</xsl:attribute>
+        <xsl:attribute name="start-indent">0mm</xsl:attribute>
     </xsl:attribute-set>
 
     <xsl:attribute-set name="h6">
         <xsl:attribute name="font-size">0.75em</xsl:attribute>
         <xsl:attribute name="font-weight">bold</xsl:attribute>
-        <xsl:attribute name="font-style">italic</xsl:attribute>
-        <xsl:attribute name="space-before">1.67em</xsl:attribute>
-        <xsl:attribute name="space-after">0.97em</xsl:attribute>
+        <xsl:attribute name="font-style">normal</xsl:attribute>
+        <xsl:attribute name="space-before">0.8em</xsl:attribute>
+        <xsl:attribute name="space-after">0.2em</xsl:attribute>
         <xsl:attribute name="keep-with-next.within-column">always</xsl:attribute>
         <xsl:attribute name="keep-together.within-column">always</xsl:attribute>
-        <xsl:attribute name="start-indent">6mm</xsl:attribute>
+        <xsl:attribute name="start-indent">0mm</xsl:attribute>
     </xsl:attribute-set>
 
     <xsl:attribute-set name="p">
-        <xsl:attribute name="space-before">1em</xsl:attribute>
-        <xsl:attribute name="space-after">1em</xsl:attribute>
+        <xsl:attribute name="space-before">0.8em</xsl:attribute>
+        <xsl:attribute name="space-after">0.8em</xsl:attribute>
         <xsl:attribute name="text-indent">1em</xsl:attribute>
     </xsl:attribute-set>
 
@@ -1828,14 +1828,14 @@
                 </xsl:when>
             </xsl:choose>
         </xsl:variable>
-        <!-- If both height and width are specified, allow the image to be transformed to a different aspect ration -->
-        <xsl:if test="$has-height and $has-width"><xsl:attribute name="scaling">non-uniform</xsl:attribute></xsl:if>
+        <!-- If both height and width are specified, allow the image to be transformed to a different aspect ration 
+        <xsl:if test="$has-height and $has-width"><xsl:attribute name="scaling">non-uniform</xsl:attribute></xsl:if> -->
         <!-- The img attribute set contains values that scale images to 75%, in order to transform from 72 to 96 DPI;
              since the user specifies his own width and/or height, let the image scale to fit the specified values -->
-       <xsl:if test="$has-height or $has-width">
-            <xsl:attribute name="content-height">scale-to-fit</xsl:attribute>
-            <xsl:attribute name="content-width">scale-to-fit</xsl:attribute>
-        </xsl:if>
+       <xsl:attribute name="content-height">scale-down-to-fit</xsl:attribute>
+       <xsl:attribute name="content-width">scale--down-to-fit</xsl:attribute>
+       <xsl:attribute name="width">100%</xsl:attribute>
+       <xsl:attribute name="height">100%</xsl:attribute>
         <xsl:attribute name="src">
             <xsl:text>url('</xsl:text>
             <xsl:value-of select="@src"/>
@@ -1847,6 +1847,7 @@
             </xsl:attribute>
         </xsl:if>
         <!-- Scale px lengths in order to get from 72 to 96 DPI -->
+ <!--
         <xsl:if test="$has-width">
             <xsl:variable name="unit"><xsl:value-of select="translate($width, '01234567890.', '')"/></xsl:variable>
             <xsl:variable name="width-no-unit">
@@ -1875,7 +1876,8 @@
             </xsl:variable>
             <xsl:attribute name="height"><xsl:value-of select="$height-no-unit"/><xsl:value-of select="$unit"/></xsl:attribute>
         </xsl:if>
-        <xsl:if test="@border">
+ -->
+       <xsl:if test="@border">
             <xsl:attribute name="border">
                 <xsl:value-of select="@border"/>px solid</xsl:attribute>
         </xsl:if>