Index: test/it/com/xpn/xwiki/it/selenium/BacklinksTest.java
===================================================================
--- test/it/com/xpn/xwiki/it/selenium/BacklinksTest.java	(revision 19650)
+++ test/it/com/xpn/xwiki/it/selenium/BacklinksTest.java	(working copy)
@@ -53,4 +53,100 @@
         open("Test", "BacklinkTargetTest");
         assertEquals("Test.BacklinkSourceTest", getSelenium().getText("xwikicontent"));
     }
+
+    public void testMultiLingualBackLinks() throws Exception
+    {
+
+	//Open Main and Logins as Admin.
+	getSelenium().open("/xwiki/bin/view/Main/");
+	loginAsAdmin();
+	
+	// Change XwikiPreferences to Multilingual 
+	getSelenium().click("link=XWikiPreferences");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("link=General");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().select("XWiki.XWikiPreferences_0_multilingual", "label=Yes");
+	getSelenium().type("XWiki.XWikiPreferences_0_languages", "fr,ru,de");
+	getSelenium().click("formactionsac");
+	getSelenium().waitForPageToLoad("30000");
+
+	//Open Sandbox and edit the title to TrainingZoneEn.
+	getSelenium().click("link=Wiki Dashboard");
+	getSelenium().click("link=Sandbox");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("tmEditWiki");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().type("xwikidoctitleinput", "TrainingZoneEn");
+	getSelenium().click("action_save");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("tmEditWiki");
+	getSelenium().waitForPageToLoad("30000");
+
+	//Translate the document to French, edit the title to TrainingZoneFr and Save it.
+	getSelenium().click("link=fr");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().type("xwikidoctitleinput", "TrainingZoneFr");
+	getSelenium().click("action_save");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("tmEditWiki");
+	getSelenium().waitForPageToLoad("30000");
+
+	//Translate the document to French, Save it and title it as TrainingZoneRu.
+	getSelenium().click("link=ru");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().type("xwikidoctitleinput", "TrainingZoneRu");
+	getSelenium().click("action_save");
+	getSelenium().waitForPageToLoad("30000");
+
+	//Open English version and check for back links in Information Link.
+	getSelenium().click("link=en");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("Informationlink");
+        assertTextPresent("TrainingZoneEn");
+	assertTextNotPresent("TrainingZoneFr");
+	assertTextNotPresent("TrainingZoneRu");	
+
+	//Open French version and check for back links in Information Link.
+	getSelenium().click("link=fr");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("Informationlink");
+	assertTextPresent("TrainingZoneFr");
+
+	//Open Romanian version and check for back links in Information Link.
+	getSelenium().click("link=ru");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("Informationlink");
+	assertTextPresent("TrainingZoneRu");
+
+	//Delete Romanian version.
+	getSelenium().click("tmActionDelete");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("//input[@value='yes']");
+	getSelenium().waitForPageToLoad("30000");
+
+	//Delete French version.
+	getSelenium().click("link=fr");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("tmActionDelete");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("//input[@value='yes']");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("link=en");
+	getSelenium().waitForPageToLoad("30000");
+
+	//Change the XwikiPreferences to Monolingual. 
+	getSelenium().click("link=XWikiPreferences");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().click("link=General");
+	getSelenium().waitForPageToLoad("30000");
+	getSelenium().select("XWiki.XWikiPreferences_0_multilingual", "label=No");
+	getSelenium().click("formactionsac");
+	getSelenium().waitForPageToLoad("30000");
+
+	//logout.
+	getSelenium().click("headerlogout");
+	getSelenium().waitForPageToLoad("30000");
+	
+    }
 }